﻿using System;

namespace SchedulingTool
{
    public class MyAppointment:MyBaseEntity
    {
        #region Fields
        private string _endTimeZoneId;

        private bool? _isLocked;

        private bool? _isOccurrenceDeleted;

        private bool _isTimeZoneNeutral = true;

        private DateTime? _maxOccurrenceDateTime;

        private DateTime _originalOccurrenceEnd;

        private DateTime _originalOccurrenceStart;

        private string _recurrence;

        private int? _recurrenceVersion;

        private string _reminder;

        private bool? _reminderEnabled;

        private TimeSpan _reminderInterval;

        private string _rootActivityId;

        private string _startTimeZoneId;

        private string _description;

        private DateTime? _start;

        private DateTime? _end;

        private string _subject;
        #endregion

        #region Properties
        public string Description
        {
            get { return this._description; }
            set { this.SetProperty(()=>this.Description,ref this._description,value); }
        }

        public DateTime? Start
        {
            get { return this._start; }
            set { this.SetProperty(()=>this.Start,ref this._start,value); }
        }

        public DateTime? End
        {
            get { return this._end; }
            set { this.SetProperty(()=>this.End,ref this._end,value); }
        }       

        public override object KeyValue
        {
            get { return this.Id; }
        }

        public bool IsVisible { get; set; }

        public string Location { get; set; }

        public string OwningCalendarId { get; set; }

        public string OwningResourceId { get; set; }
        public object OwningResource { get; set; }
        public object OwningCalendar { get; set; }

        public string Subject
        {
            get { return this._subject; }
            set{this.SetProperty(()=>this.Subject,ref this._subject,value);}
        }
      
       
        public string EndTimeZoneId
        {
            get { return this._endTimeZoneId; }
            set { this.SetProperty(()=>this.EndTimeZoneId, ref this._endTimeZoneId, value); }
        }

        public bool? IsLocked
        {
            get { return this._isLocked; }
            set { this.SetProperty(()=>this.IsLocked, ref this._isLocked, value); }
        }

        public bool? IsOccurrenceDeleted
        {
            get { return this._isOccurrenceDeleted; }
            set { this.SetProperty(()=>this.IsOccurrenceDeleted, ref this._isOccurrenceDeleted, value); }
        }

        public bool IsTimeZoneNeutral
        {
            get { return this._isTimeZoneNeutral; }
            set { this.SetProperty(()=>IsTimeZoneNeutral, ref this._isTimeZoneNeutral, value); }
        }

        public DateTime? MaxOccurrenceDateTime
        {
            get { return this._maxOccurrenceDateTime; }
            set { this.SetProperty(()=>MaxOccurrenceDateTime, ref this._maxOccurrenceDateTime, value); }
        }

        public DateTime OriginalOccurrenceEnd
        {
            get { return this._originalOccurrenceEnd; }
            set { this.SetProperty(()=>OriginalOccurrenceEnd, ref this._originalOccurrenceEnd, value); }
        }

        public DateTime OriginalOccurrenceStart
        {
            get { return this._originalOccurrenceStart; }
            set { this.SetProperty(()=>OriginalOccurrenceStart, ref this._originalOccurrenceStart, value); }
        }

        public string Recurrence
        {
            get { return this._recurrence; }
            set { this.SetProperty(()=>Recurrence, ref this._recurrence, value); }
        }

        public int? RecurrenceVersion
        {
            get { return this._recurrenceVersion; }
            set { this.SetProperty(()=>RecurrenceVersion, ref this._recurrenceVersion, value); }
        }

        public string Reminder
        {
            get { return this._reminder; }
            set { this.SetProperty(()=>Reminder, ref this._reminder, value); }
        }

        public bool? ReminderEnabled
        {
            get { return this._reminderEnabled; }
            set { this.SetProperty(()=>ReminderEnabled, ref this._reminderEnabled, value); }
        }

        public TimeSpan ReminderInterval
        {
            get { return this._reminderInterval; }
            set { this.SetProperty(()=>ReminderInterval, ref this._reminderInterval, value); }
        }

        public string RootActivityId
        {
            get { return this._rootActivityId; }
            set { this.SetProperty(()=>RootActivityId, ref this._rootActivityId, value); }
        }

        public string StartTimeZoneId
        {
            get { return this._startTimeZoneId; }
            set { this.SetProperty(()=>StartTimeZoneId, ref this._startTimeZoneId, value); }
        }

        public long? VariantProperties { get; set; }
        #endregion
    }

    public class MyAppointmentList:MyBaseEntityList<MyAppointment>
    {
        
    }
}